import { NButton } from 'naive-ui';
import {
  defineComponent,
  nextTick,
  onMounted,
  onUnmounted,
  reactive,
  ref,
  watch
} from 'vue';
import styles from './index.module.less';
import { getImage } from './images';
import {px2vw,px2vwH} from '@/utils/index'
export default defineComponent({
  name: 'coai-guide',
  emits: ['close'],
  setup(props, { emit }) {
    const data = reactive({
      box: {
        height:'0px',
      } as any,
      show: false,
      /**
       *
            width:  px2vw(840),
            height:  px2vw(295)
       */
      steps: [
        {
          ele: '',
          eleRect: {} as DOMRect,
          img: getImage('home1.png'),
          handStyle: {
            top: '0.91rem'
          },
          imgStyle: {
            top:  px2vw(-200),
            left: px2vw(295),
            width:  px2vw(840),
            height:  px2vw(295)
          },
          btnsStyle: {
            bottom:px2vw(200),
            left:  px2vw(540),
          },
          boxStyle:{
            border:'none',
            width:'0px',
            height:'0px',
            backgroundColor: 'transparent'
            // visibility: 'hidden'
          },
          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          }
        },
        // {
        //   ele: '',
        //   img: getImage('home2.png'),
        //   imgStyle: {
        //     top: '100%',
        //     left:  px2vw(-250),
        //     width: px2vw(401),
        //     height: px2vw(227)
        //   },
        //   btnsStyle: {
        //     bottom: '30px',
        //     left: px2vw(-90),
        //   },
        //   boxStyle:{
        //     borderRadius:'25px'
        //   },
        //   eleRectPadding:{
        //     left:7,
        //     top:7,
        //     width:14,
        //     height:14
        //   }

        // },
        {
          ele: '',
          img: getImage('home3.png'),
          handStyle: {
            top: '-1.39rem',
            left: '0.17rem',
            transform: 'rotate(180deg)'
          },
          imgStyle: {

            width:  px2vw(454),
            height:  px2vw(227),
            left:px2vw(282)
          },
          btnsStyle: {
            bottom: '30px',
            left:px2vw(450)
          },
          eleRectPadding:{
            left:44,
            top:44,
            width:88,
            height:88
          }
        },
        {
          ele: '',
          img: getImage('home4.png'),
          handStyle: {
            top: '-1.39rem',
            left: '1.4rem',
            transform: 'rotate(180deg)'
          },
          imgStyle: {
            left:  px2vw(-310),
            width:  px2vw(477),
            height:  px2vw(227),
          },
          btnsStyle: {
            bottom: '30px',
          },
          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          }
        },
        {
          ele: '',
          img: getImage('home5.png'),
          handStyle: {
            top: '-1.39rem',
            left: '1.4rem',
            transform: 'rotate(180deg)'
          },
          imgStyle: {
            top: '0',
            width:  px2vw(610),
            height:  px2vw(290),
            left: px2vw(38)
          },
          btnsStyle: {
            bottom: '80px',
            left: px2vw(195),
            'justify-content': 'center',
            padding: 0
          },
          eleRectPadding:{
            left:7,
            top:7,
            width:14,
            height:14
          },
          type:'bottom'
        }
      ],
      step: 0
    });
    const tipShow = ref(false);
    const guideInfo = localStorage.getItem('teacher-guideInfo');
    if (guideInfo && JSON.parse(guideInfo).homeGuide) {
      tipShow.value = false;
    } else {
      tipShow.value = true;
    }
    const getStepELe = () => {

      const ele: HTMLElement = document.getElementById(`home-${data.step}`)!;
      console.log(`coai-${data.step}`,data.steps[data.step].eleRectPadding);
      if (ele) {
        const eleRect = ele.getBoundingClientRect();
        const left = data.steps[data.step].eleRectPadding?.left || 0;
        const top = data.steps[data.step].eleRectPadding?.top || 0;
        const width = data.steps[data.step].eleRectPadding?.width || 0;
        const height = data.steps[data.step].eleRectPadding?.height || 0
        data.box = {
          left: eleRect.x - left+ 'px',
          top: eleRect.y - top +'px',
          width: eleRect.width + width+'px',
          height: eleRect.height +height+ 'px'
        };
      }
    };
    onMounted(() => {
      getStepELe();
      window.addEventListener("resize", resetSize);
    });
    const resetSize = ()=>{
      getStepELe();
    }

    onUnmounted(()=>{
      window.removeEventListener("resize", resetSize);
    })

    const handleNext = () => {
      if (data.step >= 4) {
        endGuide();
        return;
      }
      data.step = data.step + 1;
      getStepELe();
    };

    const endGuide = () => {
      let guideInfo =
        JSON.parse(localStorage.getItem('teacher-guideInfo') || '{}') || null;
      if (!guideInfo) {
        guideInfo = { homeGuide: true };
      } else {
        guideInfo.homeGuide = true;
      }
      localStorage.setItem('teacher-guideInfo', JSON.stringify(guideInfo));
      tipShow.value = false;
      //  localStorage.setItem('endC')
    };
    return () => (
      <>
        {tipShow.value ? (
          <div
            v-model:show={tipShow.value}
            class={['n-modal-mask', 'n-modal-mask-guide']}>
            <div class={styles.content} onClick={() => handleNext()}>
              <div
                class={styles.backBtn}
                onClick={(e: Event) => {
                  e.stopPropagation();
                  endGuide();
                }}>
                跳过
              </div>
              <div
                class={styles.box}
                style={{...data.box,...data.steps[data.step].boxStyle}}
                id={`modeType-${data.step}`}>

                {data.steps.map((item: any, index) => (

                  <div
                    onClick={(e: Event) => e.stopPropagation()}
                    class={styles.item}
                    style={ item.type=='bottom'?  {
                      display: index === data.step ? '' : 'none',
                      left: `${item.eleRect?.left}px`,
                      top:`-${item.imgStyle?.height}`

                    }:{
                      display: index === data.step ? '' : 'none',
                      left: `${item.eleRect?.left}px`,
                     top: `${data.box?.height}`,

                    }}>
                    <img
                      class={styles.img}
                      style={item.imgStyle}
                      src={item.img}
                    />
                    {/* <img
                      class={styles.iconHead}
                      style={item.handStyle}
                      src={getImage('indexDot.png')}
                    /> */}
                    <div class={styles.btns} style={item.btnsStyle}>
                      {data.step + 1 == data.steps.length ? (
                        <>
                         <div
                            class={[styles.endBtn]}
                            onClick={() => endGuide()}>
                            完成
                          </div>
                          <div
                            class={styles.nextBtn}
                            onClick={() => {
                              data.step = 0;
                              getStepELe();
                            }}>
                            再看一遍
                          </div>

                        </>
                      ) : (
                        <div class={styles.btn} onClick={() => handleNext()}>
                          下一步 ({data.step + 1}/{data.steps.length})
                        </div>
                      )}
                    </div>
                  </div>
                ))}
              </div>
            </div>
          </div>
        ) : null}
      </>
    );
  }
});
